/*   
     $Log: application_layer.c,v $
     Revision 4.1  1996/08/29 02:08:52  tlin
     foo

     Revision 4.0  1996/08/23 20:06:37  tlin
     bump to mickey mouse version

     Revision 3.15  1996/08/23 14:48:35  tlin
     make it work when not doX

 * Revision 3.14  96/07/25  13:15:19  tlin
 * foo
 * 
 * Revision 3.13  96/07/25  05:59:52  tlin
 * fix interval for bulk send
 * 
     Revision 3.12  1996/07/25 05:12:50  tlin
     if data[0]=='G' auto send

     Revision 3.11  1996/07/25 04:11:21  tlin
     foo

     Revision 3.10  1996/07/25 02:36:34  tlin
     cise_show_msg() -> cise_recv_msg()

     Revision 3.9  1996/07/14 22:35:43  tlin
     in cn_send(), take care of data==NULL

     
     */

#include "cisePort.h"
#include "sim.h"
#include "list.h"
#include "main.h"
#include "route_activity.h"
#include "application_layer.h"

#include "application_layer_wrappers.c"

caddr_t
application_layer_action(src,cn,type,pdu,arg)
     Component *src;
     APPLICATION_LAYER_ENTITY_TYPE *cn;
     int type;
     PDU_TYPE *pdu;
     caddr_t arg;

{

   caddr_t result = NULL;

   switch (type)  {

   case MY_SEND_A_PDU:
      result = cn_send(cn,arg);  
      break;

   case EV_RECEIVE:
      result = cn_receive(cn,pdu);
      break;

   app_other_event_handlers();
   
   default:
      break;


    }

  return(result);
}

/*****************************************/
static caddr_t cn_send(register APPLICATION_LAYER_ENTITY_TYPE *cn, char *data)
{
    tick_t interval;
  
    tick_t time;
    Neighbor *n;
    int space;
    PDU_TYPE *pdu;
  
  
    if (USECS_TO_TICKS(pval(cn, cn_start_time)->u.d) <= ev_now() ) {   
	if ((cn->cn_num_sent<
	     (pval(cn,cn_trans_size)->u.d*1000000/A_PDU_SIZE/8))
	    && (USECS_TO_TICKS(pval(cn, cn_stop_time)->u.d) > ev_now()) ) {

	    time = ev_now();

	    n = ((Neighbor *) cn->cn_neighbors->l_head);
	    space = (n->n_c->iq_limit - n->n_c->iq_length);
      
	    /* RG: space is always available in the DLC */
	    if(space > 0){
		pdu = pdu_alloc(); 
		pdu->type = TYPE_IS_A_PDU;
		pdu->u.a_pdu.snode = 
		    get_number_from_string(cn->cn_name);
	
		pdu->u.a_pdu.dnode = (int) cn->cn_destination->u.d;
		if (M.doX) {
		    if (data) {
			memcpy(pdu->u.a_pdu.data, data, DATASIZE);
			if (data[0]=='G') {
			    interval=
				USECS_TO_TICKS(((A_PDU_SIZE*8.0)/
						(pval(cn,cn_bit_rate)->u.d)));
			    Cise_SendBulk1(data, interval);
			}
			free(data);
		    } else {
			memcpy(pdu->u.a_pdu.data,"MInitial message",DATASIZE);
		    }
		} else {
		    /* sends junk data when not doX */
		} 

		if (M.doX)
		    route_activity((Component*)cn, 
				   ((Neighbor*)cn->cn_neighbors->l_head)->n_c, 
				   10, 1, 0); 
	
		ev_enqueue(EV_RECEIVE, (Component *)cn, 
			   ((Neighbor *) cn->cn_neighbors->l_head)->n_c,
			   ev_now()+10,
			   (((Neighbor*)cn->cn_neighbors->l_head)->n_c->co_action), 
			   pdu, NULL);
	    }


	    if (!M.doX) {
		/* Calculate the next pdu generation time */
		interval=USECS_TO_TICKS(((A_PDU_SIZE*8.0)/
					 (pval(cn,cn_bit_rate)->u.d)));
		/* schedule a pdu to be generated at that time */
		ev_enqueue(MY_SEND_A_PDU, (Component *)cn, (Component *)cn,
			   ev_now()+interval,application_layer_action, 
			   NULL, NULL);
	    }
	    cn->cn_num_sent++;
	}
    } else {
        interval = USECS_TO_TICKS(pval(cn, cn_start_time)->u.d);
	ev_enqueue(EV_START, (Component *)cn, (Component *)cn, 
		   interval, application_layer_action, NULL,NULL);
    } 

    return ((caddr_t)cn);
}

/********************************************************************/
static caddr_t
cn_receive(cn, pdu)
    register APPLICATION_LAYER_ENTITY_TYPE *cn;
    register PDU_TYPE *pdu;
{
	cn->cn_pkts_recvd->u.i += 1;
	log_param((Component *)cn, pval(cn, cn_pkts_recvd));
	
	/*printf("node %s: received msg %s\n",cn->cn_name,pdu->u.a_pdu.data);*/
	if (M.doX) 
	  cise_recv_msg(cn->cn_name,pdu->u.a_pdu.data);

	pdu_free(pdu);
	   
	return ((caddr_t)cn);
}


/********************************************************************/

