





extern Log pkt_log;
extern int doXstuff;

static caddr_t cn_reset(),cn_create(),cn_neighbor(),
               cn_receive(),
               cn_uneighbor(),cn_route(),cn_hops(),cn_send();

#define APPLICATION_LAYER_ENTITY_TYPE APPConnectiont

#define app_other_event_handlers()                      \
{							\
  case EV_RESET:					\
       result=cn_reset(cn);				\
       break;						\
  case EV_CREATE:					\
       result = cn_create((char *)arg);			\
       break; 						\
  case EV_DEL:						\
       comp_delete((Component *)cn);			\
       result = (caddr_t)cn;				\
       break;						\
  case EV_NEIGHBOR:					\
       result = cn_neighbor(cn, (Component *)arg);	\
       break;						\
  case EV_UNEIGHBOR:					\
       result = cn_uneighbor(cn, (Component *)arg);	\
       break;						\
  case EV_LEGAL_NEXT_HOPS:				\
       result = cn_hops(cn);				\
       break;						\
  case EV_MAKE_ROUTE:					\
       result = cn_route(cn, (list *)arg);		\
       break;						\
  case EV_START:					\
       result = cn_send(cn,NULL);			\
       break;						\
  case EV_UPDATE_ROUTE_ACTIVITY:			\
       update_routes(src,(Component *)cn);              \
       result=(caddr_t)cn;				\
       break;                                           \
}

/***************************************/
static caddr_t
cn_reset(cn)
    register APPConnectiont *cn;
{
   cn->cn_num_sent = 0;
   cn->cn_pkts_recvd->u.i = 0;
   log_param((Component *)cn, pval(cn, cn_pkts_recvd));

  return((caddr_t)cn);
}

/****************************************/
static caddr_t
cn_create(name)
     register char *name;
{
    APPConnectiont *newcn;

   /* Memory for the component structure. */
   newcn = (APPConnectiont *)sim_malloc(sizeof(APPConnectiont));

   /* First things first-- copy name into the new structure. */
   strncpy(newcn->cn_name, name, 40);

   /* have to create a neighbor list */
  newcn->cn_neighbors= l_create();
  newcn->cn_params = q_create();
  newcn->cn_type = APPLICATION_LAYER_TYPE;
  newcn->cn_class = APP_CLASS;
  newcn->cn_action = (PFP)application_layer_action;
  newcn->cn_menu_up = FALSE;
  newcn->cn_flash = 0;

 /* Initialize the parameters */
  newcn->cn_Name = param_init ((Component*)newcn, "Name",
             (PFD)NULL, (PFP)make_name_text, (PFP)make_short_name_text,
             param_input_name,
             0, DisplayMask | InputMask | CanHaveLogMask, 0.0);


  newcn->cn_bit_rate = param_init ((Component *)newcn,
             "Bit Rate (Mbits/s)",
             (PFD)NULL, (PFP)make_double_text, (PFP)make_short_double_text,
              param_input_double,
             0, DisplayMask | InputMask, 0.0);

  newcn->cn_bit_rate->u.d = 155.52;

  newcn->cn_start_time = param_init ((Component *)newcn,
             "Start time (usecs)",
             (PFD)NULL, (PFP)make_double_text, (PFP)make_short_double_text,
              param_input_double,
             0, DisplayMask | InputMask, 0.0);
   newcn->cn_start_time->u.d = 0;
 
  newcn->cn_destination = param_init ((Component *)newcn,
             "Destination node",
             (PFD)NULL, (PFP)make_double_text, (PFP)make_short_double_text,
              param_input_double,
             0, DisplayMask | InputMask, 0.0);
   newcn->cn_destination->u.d = 0;

  newcn->cn_trans_size = param_init (( Component *) newcn,
             "Number of MBits to be sent",
             (PFD)NULL, (PFP)make_double_text, (PFP)make_short_double_text,
              param_input_double,
         0, DisplayMask | InputMask, 0.0);
    newcn->cn_trans_size->u.d = 100;

   newcn->cn_pkts_recvd = param_init ((Component *)newcn, "Number of Pkts Received", 
                int_calc, (PFP)make_int_text, (PFP)make_short_int_text,
                 (PFI)NULL, TIME_HISTORY, DisplayMask | CanHaveMeterMask
                  | CanHaveLogMask, 0.0);


  newcn->cn_stop_time = param_init ((Component *)newcn,
             "Stop time (usecs)",
             (PFD)NULL, (PFP)make_double_text, (PFP)make_short_double_text,
              param_input_double,
             0, DisplayMask | InputMask, 0.0);
newcn->cn_stop_time->u.d = 200000.0;

     newcn->cn_num_sent = 0;

     cise_register_node(newcn);
   return((caddr_t)newcn);
}

/****************************************/
static caddr_t
cn_neighbor(cn,c)
     register APPConnectiont *cn;
     register Component *c;
{
     register Neighbor *n;
    if (!(n=add_neighbor((Component*)cn,c,1,1,DLC_CLASS)))
        return ((caddr_t)NULL);
    return ((caddr_t)n);
}

/*****************************************/
static caddr_t
cn_uneighbor(cn,c)
   register APPConnectiont *cn;
   register Component *c;
{
   return ((caddr_t)remove_neighbor((Component *)cn,c));
}

/******************************************/

static caddr_t
cn_hops(cn)
   register APPConnectiont *cn;
{
   register list *nlist;
   register Neighbor *n;

    nlist=l_create();

    for (n= (Neighbor *) cn->cn_neighbors->l_head;n;n=n->n_next)
         if (n->n_c->co_class == DLC_CLASS)
            l_addt(nlist,(caddr_t)n->n_c);

return ((caddr_t)nlist);
}

/*****************************************/
static int
get_number_from_string(p)
char *p;
{

while(!isdigit(*p)) p++;

return atoi(p);
}


/* ***************************************/
/*******************************************/
static caddr_t
cn_route(cn,route_list)
         register APPConnectiont *cn;
         list *route_list;
{

#ifdef NOTDEF
         Param *p;
         Component *this_component;
         Component *other_component;
         Neighbor *n1;
         Neighbor *n2;
    

         p=param_init((Component *)cn,"Other End Connection :               ",
                      int_calc,make_int_text,make_short_int_text,
                      (PFI)NULL,0,DisplayMask | CanHaveLogMask,0.0);

        if ((((Component *)route_list->l_head->le_data)->co_name[3] !=
              cn->cn_name[3]) || 
             (((Component *)route_list->l_head->le_data)->co_name[2] !=
              cn->cn_name[2]) || 
              (((Component *)route_list->l_head->le_data)->co_name[1] !=
              cn->cn_name[1]) || 
              (((Component *)route_list->l_head->le_data)->co_name[0] !=
              cn->cn_name[0]) ) 
            strcat(p->p_name,((Component *)route_list->l_head->le_data)->
                              co_name);
        else strcat(p->p_name,((Component *)route_list->l_tail->le_data)->
                               co_name);
 
         cn->cn_vpi=vpi;

         this_component = (Component *)route_list->l_head->le_data;
         other_component = (Component *)route_list->l_tail->le_data ;      

         n1= (Neighbor *)this_component->co_neighbors->l_head;
         n2= (Neighbor *)other_component->co_neighbors->l_head;

         if (n1->n_c->co_name[3] == n2->n_c->co_name[3])
            cn->cn_simple_connection=1;
         

          
#endif
		    return ((caddr_t)cn); /* return something non-null */

}
 

