/* 
   $Log:	link.c,v $
 * Revision 4.2  96/08/29  02:23:55  tlin
 * foo
 * 
   Revision 4.1  1996/08/29 02:16:27  tlin
   add different frame types to cise_st_event()

   Revision 4.0  1996/08/23 20:06:37  tlin
   bump to mickey mouse version

   Revision 3.7  1996/07/31 16:39:59  tlin
   st diagram ok1

   */

#include "cisePort.h"
#include "sim.h"
#include "list.h"
#include "main.h"
#include "route_activity.h"
#include "link.h"
#include "link_wrappers.c"
#include "random.h"


caddr_t
link_action(src,cn,type,pdu,arg)
     Component *src;
     register LINK_ENTITY_TYPE *cn;
     int type;
     PDU_TYPE *pdu;
     caddr_t arg;

{

   caddr_t result = NULL;

   switch (type)  {


   case EV_RECEIVE:
      result = cn_receive(cn,src,pdu);
      break;

   link_other_event_handlers();
   
   default:
      break;


    }

  return(result);
}

/********************************************************************/
static caddr_t
cn_receive(cn,src, pdu)
    register LINK_ENTITY_TYPE *cn;
    Component *src;
    PDU_TYPE *pdu;
{

 
 
	register Neighbor *n;
	register Component *c;
	tick_t tics;



   for (n=(Neighbor *)cn->cn_neighbors->l_head;n;n=n->n_next)
     {
       if (n->n_c != src) break;
     }
   c = n->n_c;
   
   tics = USECS_TO_TICKS(cn->cn_delay->u.d);
   
   
   if (Cise_random()/((double) MAX_RANDOM_NUMBER)  < cn->cn_err->u.d )
     pdu->u.d_pdu.error = YES;
   
   if (M.doX) {
       char frame_type[32]="(unknown frame type)";
       switch (pdu->u.d_pdu.type) {
       case D_INFO: 
	   sprintf(frame_type,"Info(%d)",pdu->u.d_pdu.seq_number); 
	   break;
       case D_ACK:
	   sprintf(frame_type,"ACK(%d)",pdu->u.d_pdu.ack_number); 
	   break;
       case D_NAK:
	   sprintf(frame_type,"NAK(%d)",pdu->u.d_pdu.ack_number); 
	   break;
       }
       route_activity((Component *)cn, c, tics, 4, 0); 
       cise_st_event(pdu->u.d_pdu.curr_node,
		     pdu->u.d_pdu.next_node,
		     ev_now(), ev_now()+tics, frame_type,
		     pdu->u.d_pdu.error);
   }

   ev_enqueue(EV_RECEIVE, (Component *)cn, c, ev_now()+tics,c->co_action,
	      (PDU_TYPE *) pdu, (caddr_t)NULL);
   
   return ((caddr_t)cn);
}


/********************************************************************/





