
/* skeleton dlc_layer.c for lab1 */


#include "cisePort.h"
#include "sim.h"
#include "component.h"
#include "comptypes.h"
#include "list.h"
#include "eventdefs.h"
#include "main.h"
#include "route_activity.h"
#include "sim_tk.h"
#include "dlc_layer.h"

/****************************************************/
/* ----- DO NOT REMOVE OR MODIFY THIS FUNCTION ---- */
static 
dlc_layer_receive(DLC_LAYER_ENTITY_TYPE *dlc_layer_entity,
		  GENERIC_LAYER_ENTITY_TYPE *generic_layer_entity,
		  PDU_TYPE *pdu)
{
 if (DatalinkFromApplication(generic_layer_entity)) {

      DatalinkToPhysical(dlc_layer_entity, pdu);

 } else if (DatalinkFromPhysical(generic_layer_entity)) {

      DatalinkToApplication(dlc_layer_entity, pdu);
      
	   
 }
   return 0;
}


/********************************************************************/

DatalinkToPhysical(DLC_LAYER_ENTITY_TYPE *dlc_layer_entity,
		 PDU_TYPE *pdu_from_application)
{
   PDU_TYPE *pdu_to_physical; /* use pdu_alloc() to create this */ 

   /* just a sanity check */ 
   if (pdu_from_application->type != TYPE_IS_A_PDU) panic("Empty a_pdu\n");

   /* ------ DO YOUR CODING HERE ----- */
   /* create d_pdu: use pdu_alloc() */
   /* use bcopy to copy the contents */
   
   /* send to phy */
   /* Use the macro:
      send_pdu_to_physical_layer(dlc_layer_entity,pdu_to_physical);
      */
   
   pdu_free(pdu_from_application);
   return 0;
}


/* -------------------------------------------------------- */
DatalinkToApplication(DLC_LAYER_ENTITY_TYPE *dlc_layer_entity,
		    PDU_TYPE *pdu_from_physical)
{
    PDU_TYPE * pdu_to_application;


    /* just a sanity check */ 
    if (pdu_from_physical->type != TYPE_IS_D_PDU) panic("Empty d_pdu\n");

    /* ------ DO YOUR CODING HERE ----- */
    /* Use the macro:
       send_pdu_to_application_layer(dlc_layer_entity,pdu_to_application);
       */
  
    /* extract a_pdu, check for error, and send to application if error-free */

    pdu_free(pdu_from_physical);
    return 0;
}

