
/*
   $Log:	cise.C,v $
 * Revision 4.17  96/10/13  14:55:22  sli
 * removed old comments
 * 
 * Revision 4.16  96/10/13  14:46:52  sli
 * foo
 * 
 * Revision 4.15  96/10/13  14:45:52  sli
 * just a test. Ignore it. 
 * 
 * Revision 4.14  96/09/25  17:19:31  tlin
 * foo
 * 
   Revision 4.13  1996/09/24 20:20:52  tlin
   add make_node_graph() and make_space_time()

   Revision 4.12  1996/09/20 07:09:05  tlin
   use dprintf()

   Revision 4.11  1996/09/20 06:46:01  tlin
   MdebugLevel

   Revision 4.10  1996/09/20 06:29:43  tlin
   clear transmitted image; works.

   Revision 4.9  1996/09/20 06:02:24  tlin
   handles re-display for transmitted picture,
   although off-by-2 problem persists

   Revision 4.8  1996/09/20 04:59:30  tlin
   use Pixmap indtead of XImage for re-draw purpose; seems better

   Revision 4.7  1996/09/19 17:29:58  tlin
   try to use ximage for expose event; not success yet.

   Revision 4.6  1996/09/19 09:24:14  tlin
   use struct to hold App layer info

   Revision 4.5  1996/09/19 08:57:43  tlin
   offset by 2. unsolved puzzle yet.

   Revision 4.4  1996/09/19 08:17:14  tlin
   first few packets now draws.

   Revision 4.3  1996/09/19 07:49:47  tlin
   send msg/graph triggers run if not already running

   Revision 4.2  1996/09/19 07:37:39  tlin
   replace all Tk_DoWhenIdle() by Tk_CreateTimerHandler() so that
   GUI response will not be too slow

   Revision 4.1  1996/08/27 14:42:58  tlin
   foo

 * Revision 4.0  96/08/23  20:02:27  tlin
 * bump to mickey mouse version
 * 
   */

/* Tk inclusion for CISE -- tlin@cis  */


#include "cisePort.h"
extern "C" {
#include "sim.h"
#include "list.h"
#include "file.h"
#include "event.h"
#include "random.h"
#include "main.h"
#include "route_activity.h"
#include "../components.src/application_layer.h"
#include "tkWin.h"
};
#include "cise.h"


int Tcl_AppInit(Tcl_Interp *interp)
{
    if (Tcl_Init(interp) == TCL_ERROR) {
        return TCL_ERROR;
    }
    if (Tk_Init(interp) == TCL_ERROR) {
        return TCL_ERROR;
    }
    if (Cise_Init(interp) == TCL_ERROR) {
        return TCL_ERROR;
    }
/*
    tcl_RcFileName = "~/.wishrc";
*/ 
    return TCL_OK;
}


int Cise_Init(Tcl_Interp *interp)
{
    M.interp=interp;

    Tcl_CreateCommand(interp, "cise_init2",    Cise_Init2,       NULL, NULL);

    Tcl_CreateCommand(interp, "cise_run",      Cise_RunCmd,      NULL, NULL);
    Tcl_CreateCommand(interp, "cise_step",     Cise_StepCmd,     NULL, NULL);
    Tcl_CreateCommand(interp, "cise_pause",    Cise_PauseCmd,    NULL, NULL);
    Tcl_CreateCommand(interp, "cise_resume",   Cise_ResumeCmd,   NULL, NULL);
    Tcl_CreateCommand(interp, "cise_stopTime", Cise_StopTimeCmd, NULL, NULL);
    Tcl_CreateCommand(interp, "cise_delay",    Cise_Delay,       NULL, NULL);

    Tcl_CreateCommand(interp, "cise_load",     Cise_Load,        NULL, NULL);
    Tcl_CreateCommand(interp, "cise_save",     Cise_Save,        NULL, NULL);

    Tcl_CreateCommand(interp, "cise_time",     Cise_Time,        NULL, NULL);
    Tcl_CreateCommand(interp, "cise_srandom",  Cise_Srandom,     NULL, NULL);

    Tcl_CreateCommand(interp, "cise_send",     Cise_Send,        NULL, NULL);
    Tcl_CreateCommand(interp, "cise_sendBulk", Cise_SendBulk,    NULL, NULL);
    Tcl_CreateCommand(interp, "cise_getImg",   Cise_GetImg,      NULL, NULL);
    Tcl_CreateCommand(interp, "cise_clrImg",   Cise_ClrImg,      NULL, NULL);

    M.libDir = getenv("CISE_LIBRARY_Lab1");   // needs to be redo in cise.C because the result 
    if (M.libDir == NULL) {              // from getenv() is not permanent
     
		M.libDir ="D:\\CISE\\DEVELOPING\\Lab1\\SIM.SRC";

    }

    Tcl_SetVar (interp, "cise_library", M.libDir, TCL_GLOBAL_ONLY);

    Tcl_LinkVar(interp, "Mbg_name",   (char*)&M.bg_name,   TCL_LINK_STRING);
    Tcl_LinkVar(interp, "Mfilename",  (char*)&M.filename,  TCL_LINK_STRING);
    Tcl_LinkVar(interp, "Mrunning",   (char*)&M.running,   TCL_LINK_INT);
    Tcl_LinkVar(interp, "MdebugLevel",(char*)&M.debugLevel,TCL_LINK_INT);

    initBulkData();

    interp->result="ok";
    return TCL_OK;
}


/* some variables (eg. canvas) are initialized in the script, which is run 
   after Cise_Init(). Reference to these variable are not available in Cise_Init(). */
int Cise_Init2(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    M.tk_canvas=Tk_NameToWindow(interp, ".c", Tk_MainWindow(interp));
    M.display  =Tk_Display (M.tk_canvas);
    M.canvas   =Tk_WindowId(M.tk_canvas);
    M.depth    =Tk_Depth   (M.tk_canvas);
    M.gc       =Tk_GetGC   (M.tk_canvas, 0, NULL);
	M.interp = interp;
    Tk_CreateEventHandler(M.tk_canvas, ExposureMask, refresh_route_activity, NULL);

    {
	/* create several gcxor with different colors */
	Tk_Uid uname;
	/* hard-coded; need modify later */
	char   *names[]={"bomb", "app", "dlc", "phy", "link"};
	char   *name;
	XColor *xcolor;
	int    i;

	uname=Tk_GetUid(M.bg_name);
	M.bg_color=Tk_GetColor(interp, M.tk_canvas, uname);

	for (i=0; i<5; i++) {
	    M.gccopy[i]=XCreateGC(M.display, M.canvas, 0, NULL);
	    M.gcxor[i] =XCreateGC(M.display, M.canvas, 0, NULL);
	    XSetFunction(M.display, M.gcxor[i], GXxor);

	    if ((name=Tcl_GetVar2(interp, "icon_color", names[i], 
				 TCL_LEAVE_ERR_MSG))==NULL) {
		printf("    Internal error #1001. Please report to "
		       "the author.\n");
		continue;
	    }
	    uname=Tk_GetUid(name);
	    xcolor=Tk_GetColor(interp, M.tk_canvas, uname);
	    M.colors[i]=xcolor->pixel ^ M.bg_color->pixel;
	    XSetForeground(M.display, M.gccopy[i], xcolor->pixel);
	    XSetForeground(M.display, M.gcxor[i],  M.colors[i]);
	}
    }

    interp->result="ok";
    return TCL_OK;
}

int Cise_RunCmd(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (M.running) {
	interp->result="already running";
	return TCL_OK;
    }

    M.running=1;

    sim_reset(M.comps);
    sim_start(M.comps);
    Tk_CreateTimerHandler(M.delay, nothing2do, 0);

    interp->result="running";
    return TCL_OK;
}

int Cise_StepCmd(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    M.single_step=1;
    if (!M.running) 
	Cise_RunCmd(clientData, interp, argc, argv);
    else 
	Tk_CreateTimerHandler(M.delay, nothing2do, 0);
    interp->result="single step";
    return TCL_OK;
}

int Cise_PauseCmd(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (!M.running) {
	interp->result="You have to run it first";
	return TCL_OK;
    }
    if (M.paused) {
	interp->result="already paused";
	return TCL_OK;
    }
    M.paused=1;
    interp->result="paused";
    return TCL_OK;
}

int Cise_ResumeCmd(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (!M.running) {
	interp->result="You have to run it first";
	return TCL_OK;
    }
    if (M.paused || M.single_step) {
	M.paused=0;
	M.single_step=0;
	Tk_CreateTimerHandler(M.delay, nothing2do, 0);
    }
    interp->result="running";
    return TCL_OK;
}

int Cise_StopTimeCmd(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    tick_t tmp=M.stoptime;

    if (argc==2) {
	sscanf(argv[1], "%lu", &M.stoptime);
    }
    sprintf(interp->result, "%lu", tmp);
    return TCL_OK;
}

int Cise_Delay(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    int tmp=M.delay;
    
    if (argc==2) {
	sscanf(argv[1], "%d", &M.delay);
    }
    if (M.delay<1) M.delay=1;
    if (M.delay>(1<<30))  M.delay=1<<30;
    sprintf(interp->result, "%d", tmp);
    return TCL_OK;
}

int Cise_Load(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (M.filename==NULL)  {
	interp->result="No file name";
	return TCL_OK;
    }
    if ( (M.comps=read_world(M.filename))==NULL ) 
	sprintf(interp->result, "Unable to load file %s", M.filename);
    else 
	sprintf(interp->result, "File %s loaded", M.filename);

    return TCL_OK;
}

int Cise_Save(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (M.filename==NULL)  {
	interp->result="No file name";
	return TCL_ERROR;
    }
    interp->result="Function not supported yet";

    return TCL_OK;
}

int Cise_Time(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    sprintf(interp->result, "%.3f", ev_now()/1000.0);
    return TCL_OK;
}

int Cise_Srandom(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (argc>=2) {
	if (strcmp(argv[1], "rand")==0) 
	    M.seed = (int)time((long *)NULL);
	else 
	    sscanf(argv[1], "%d", M.seed);
    }
    Cise_srandom(M.seed);
    sprintf(interp->result, "%d", M.seed);
    return TCL_OK;
}


extern "C" int cise_st_event(int node1, int node2,
			     ulong t1, ulong t2, char *label, int error)
{
    char buf[1024];
    int  dir=0;

    if (node1>node2) {
	int t=node1; node1=node2; node2=t;
	dir=1;
    }

    sprintf(buf, "st_event %d %d %d %.1f %.1f \"%s\" %d",
	    node1, node2, dir, t1/1000.0, t2/1000.0, label, error);
    //printf("in cise_st_event(), %s\n", buf);
    Tcl_Eval(M.interp, buf);
    return 0;
}

// ----------------------------------------------
//
//
//  info kept at each app layer
//
//
// ----------------------------------------------


static struct app_info {
    APPConnectiont *AppLayer;
    int            AppIndex;
    HDC       hdc;
	HDC       hdcMem;
	HBITMAP hBitmap;
    Tk_Window      tk_w;
    int            width, height;
	int            current_x;
	int            current_y;
} App[10];

extern "C" int cise_register_node(APPConnectiont *app)
{
    static i=0;
    int    idx;
    App[i].AppLayer=app;
    sscanf(app->cn_name,"app%d", &idx);
    App[idx].AppIndex=i++;
    App[i].hdc=NULL;
	App[i].hdcMem=NULL;
	App[i].hBitmap=NULL;
    App[i].width=App[i].height=-1;
	App[i].current_x = App[i].current_y = 0;
	return 0;
}

int Cise_Send(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    char *data;
    int src;
    if (argc!=3) {
	interp->result="usage: cise_send <src node> <msg>";
	return TCL_ERROR;
    }
    if (!M.running) 
	Cise_RunCmd(clientData, interp, argc, argv);

    sscanf(argv[1],"%d",&src);
    src=App[src].AppIndex;

    data=(char*)malloc(DATASIZE);
    data[0]='M';
    memcpy(data+1,argv[2],DATASIZE-1);
    ev_enqueue(MY_SEND_A_PDU, 
	       (Component *)App[src].AppLayer, (Component *)App[src].AppLayer, 
	       ev_now(),application_layer_action, (PDU_TYPE *)NULL, data);
    Tk_CreateTimerHandler(M.delay, nothing2do, 0);
    interp->result="OK";
    return TCL_OK;
}


typedef struct {
    uchar *data;
    int   width, height;
    int   size, offset;
    uchar *last_sent;
    int   src;

	/* Win95 Port */
	HDC hdc;
	HDC hdcMem;
    HBITMAP hBitmap;    
} bulkData_t;

static bulkData_t BulkData[10];

int initBulkData()
{
#   define d BulkData[i]    
    for (int i=0; i<10; i++) {
	d.data=NULL;
	d.width=d.height=0;
	d.size=d.offset=0;
	d.last_sent=NULL;
	d.src=-1;
	d.hdc=NULL;
	d.hdcMem=NULL;
	d.hBitmap=NULL;
    }
    return 0;
#   undef d
}

extern "C" int Cise_SendBulk1(uchar *data, int interval);
int Cise_SendBulk(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    bulkData_t *bd;
    int  src, src_i;
    if (argc!=2) {
	interp->result="usage: cise_send <src node>";
	return TCL_ERROR;
    }
    if (!M.running) 
	Cise_RunCmd(clientData, interp, argc, argv);

    sscanf(argv[1],"%d",&src);
    bd=&BulkData[src];
    src_i=App[src].AppIndex;

    if (bd->data==NULL) {
	interp->result="Must load graph first";
	return TCL_ERROR;
    }
    //printf("    w=%d. h=%d, size=%d\n", bd->width, bd->height, bd->size);
    bd->src=src_i;

    bd->offset=0;
    bd->last_sent=(uchar*)(src_i+1); // for starting SendBulk1()
    Cise_SendBulk1(bd->last_sent, 0);

    interp->result="OK";
    return TCL_OK;
}

#define BULKSIZE 87
#if (DATASIZE<BULKSIZE+10)
    "DATASIZE must be larger than BULKSIZE+10"
#endif
extern "C" int Cise_SendBulk1(uchar *data, int interval)
{
#   define bd BulkData[i]
    int  i;

    for (i=0; i<10 && data!=bd.last_sent; i++);

    if (bd.offset>bd.size)
	return 0;   // no more data

    data=(uchar*)malloc(DATASIZE);
    data[0]='G';
    data[1]=bd.width%256;     data[2]=bd.width/256; 
    data[3]=bd.height%256;    data[4]=bd.height/256; 
    data[5]=bd.offset%256;    data[6]=bd.offset/256; 
	data[7]=i%256;                 data[8]=i/256; /* keep bd index ; Win95 Port */
    memcpy(data+9, bd.data+bd.offset, BULKSIZE);
    bd.offset+=BULKSIZE;
    bd.last_sent=data;
    
    ev_enqueue(MY_SEND_A_PDU, 
	       (Component *)App[bd.src].AppLayer, 
	       (Component *)App[bd.src].AppLayer, 
	       ev_now()+interval,application_layer_action, NULL, (char*)data);
    
    if (interval==0) Tk_CreateTimerHandler(M.delay, nothing2do, 0);
#   undef bd

	return 0;
}

int _getImg(Display *display, Window window, bulkData_t &bd)
{
#   define   data bd.data
    XImage   *xi;
    int      x, y, i;
 
    TkWinDrawable *twdPtr = (TkWinDrawable *)window;
    
	/* Win95 Port */
	bd.hdc = GetWindowDC(twdPtr->window.handle);
	bd.hdcMem= CreateCompatibleDC(bd.hdc);
	bd.hBitmap=CreateCompatibleBitmap(bd.hdc, bd.width, bd.height);
	SelectObject(bd.hdcMem, bd.hBitmap);
    BitBlt(bd.hdcMem, 0, 0, bd.width, bd.height, bd.hdc, 0, 0, SRCCOPY);
    /* End Win95 Port */


    if (data) free(data);
    if ((data=(uchar*)malloc(bd.width*bd.height))==NULL) {
	printf("Not enough memory!!\n");
	exit(1);
    }
    
    // don't know why XGetImage() starts from 0,2. need investigation
    //   tlin@cis, 9/16/96


/*     xi = XGetImage(display, window, 0,2, bd.width, bd.height, 
		   AllPlanes, XYPixmap);
 
	
    i=0;
    for (y=0; y<bd.height; y++) {
	for (x=0; x<bd.width; x++) {
	    data[i++] = (uchar)XGetPixel(xi, x, y);
	}
    }
	
*/
    bd.size=bd.width*bd.height;
    dprintf(10,"  data[0-3]=%d %d %d %d\n", data[0],data[1],data[2],data[3]);
    return 0;
#   undef data
}


int Cise_GetImg(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
#   define w    BulkData[src].width
#   define h    BulkData[src].height
    Tk_Window tk_w;
    Display   *display;
    Window    xwin;
    int       src;

    if (argc!=5) {
	interp->result="usage: cise_getImg <node> <canvas> <width> <height>";
	return TCL_ERROR;
    }
    
    sscanf(argv[1], "%d", &src);
    sscanf(argv[3], "%d", &w);
    sscanf(argv[4], "%d", &h);
    tk_w=Tk_NameToWindow(interp, argv[2], Tk_MainWindow(interp));
    display=Tk_Display(tk_w);
    xwin=Tk_WindowId(tk_w);
    if (_getImg(display, xwin, BulkData[src])<0) {
	sprintf(interp->result,"GetImG: Not enough memory! %dx%x\n",w,h);
	return TCL_ERROR;
    }
    //printf("src=%d, data=0x%x\n", src, BulkData[src].data);

    interp->result="OK";
    return TCL_OK;
#   undef w
#   undef h
}

int cise_text_msg(char *node, char *data)
{
    int  dest;
    char buf[1024];
    sscanf(node,"app%d",&dest);
    sprintf(buf,"show_msg %d \"%s\"", dest, data);
    Tcl_Eval(M.interp, buf);

	return 0;
}

int Cise_ClrImg(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    Tk_Window tk_w;
    Display   *display;
    Window    xwin;
    int       src;
    TkWinDrawable *twdPtr;

    if (argc!=3) {
	interp->result="usage: cise_clrImg <node> <canvas>";
	return TCL_ERROR;
    }
    
    sscanf(argv[1], "%d", &src);
    tk_w=Tk_NameToWindow(interp, argv[2], Tk_MainWindow(interp));
    display=Tk_Display(tk_w);
    xwin=Tk_WindowId(tk_w);
	twdPtr = (TkWinDrawable *)xwin;
    
    ReleaseDC(twdPtr->window.handle, BulkData[src].hdc);
	DeleteDC(BulkData[src].hdcMem);
    DeleteObject(BulkData[src].hBitmap);

    XClearWindow(display, xwin);
    if (App[src].width>0) {
//	Tk_FreePixmap(display,App[src].pm);
	App[src].width=-1;
	ReleaseDC(twdPtr->window.handle, App[src].hdc);	
	 
    }

    interp->result="OK";
    return TCL_OK;
}
/*
void refresh_copied_img(ClientData clientData, XEvent *eventPtr)
{
	TkWinDrawable *twdPtr;
    HDC hdcDest;
	int i, j;

    XExposeEvent      *xev=&eventPtr->xexpose;
    struct app_info   *ap=(struct app_info *)clientData;

    if (ap->width<0)   return;

  
    twdPtr = (TkWinDrawable *)xev->window;
    hdcDest = GetWindowDC(twdPtr->window.handle);

	BitBlt(ap->hdc, 0,0, ap->width, ap->height, ap->hdcMem, 0, 0, SRCCOPY);
	 
}
*/

int _getXwinNgc(char *node, Window &xwin, GC &gc, 
		int size, int w, int h, int &dest, int index)
{
    
	
    char      canvas[100];
    Tk_Window tk_w;
    Display   *display;
    XGCValues gcv;
	 TkWinDrawable *twdPtr;
     int i, j;


    sscanf(node,"app%d",&dest);
    sprintf(canvas,".node%d.c",dest);

    tk_w=Tk_NameToWindow(M.interp, canvas, Tk_MainWindow(M.interp));
    display=Tk_Display(tk_w);
    xwin=Tk_WindowId(tk_w);
    

    gc=Tk_GetGC(tk_w,0l,&gcv);
 
	
	if (App[dest].width<0) {
 
	App[dest].width=w; App[dest].height=h;
	
	
	twdPtr = (TkWinDrawable *)xwin;   
    App[dest].hdc = GetWindowDC(twdPtr->window.handle);
    App[dest].hdcMem=CreateCompatibleDC(App[dest].hdc);
	App[dest].hBitmap=CreateCompatibleBitmap(App[dest].hdc, w, h);
	SelectObject(App[dest].hdcMem, App[dest].hBitmap);
	BitBlt(App[dest].hdcMem, 0, 0, w, h, App[dest].hdc, 0, 0, SRCCOPY);

 	// this is bad place for event handler. need further work.
	/* Win95 Tcl/Tk Tk_CreateEventHandler is not working well */
   /* Tk_CreateEventHandler(tk_w, ExposureMask, refresh_copied_img, 
			      &App[dest]);
    */
	  
 
    }
	/* refresh copied image */
 
     	
   BitBlt(App[dest].hdc, 0,0, App[dest].width, App[dest].height, App[dest].hdcMem, 0, 0, SRCCOPY);
 
	return 0;
}


int cise_graph_msg(char *node, uchar *data)
{
    int    w, h, offset, x, y, size, last, index, dest;
    Window xwin;
    GC     gc;
    Pixmap pm;
    HDC  hdcDest;
    TkWinDrawable *twdPtr;   
    
    w     =data[0]+data[1]*256;
    h     =data[2]+data[3]*256;
    offset=data[4]+data[5]*256;
	index = data[6]+data[7]*256;
    data  += 8; /* modified for Win95 port */
    
    x=offset%w; y=offset/w;
    size=w*h;
    last=min(offset+BULKSIZE, size);

    _getXwinNgc(node,xwin,gc,size,w,h, dest, index);
   
 

/* Win95 Port */

    twdPtr = (TkWinDrawable *)xwin;
    /* hdcDest = GetWindowDC(twdPtr->window.handle); */

	for ( ; offset<last; offset++) {
	 BitBlt(App[dest].hdc, x, y, 1, 1, BulkData[index].hdcMem, x, y, SRCCOPY);
     BitBlt(App[dest].hdcMem,  x, y, 1, 1, BulkData[index].hdcMem, x, y, SRCCOPY);
	 if (++x>=w) {x=0; y++;}
    }
    
	App[dest].current_x = x;
	App[dest].current_y =y;

/*	ReleaseDC(twdPtr->window.handle, hdcDest); */
	return 0;
}

extern "C" int cise_recv_msg(char *node, char *data)
{
    switch (data[0]) {
    case 'M':
	cise_text_msg(node,data+1);
	break;
    case 'G':
	cise_graph_msg(node,(uchar*)(data+1));
	break;
    default:
	printf("%s: Unknown packet type %c\n", node, data[0]);
    }

	return 0;
}


void nothing2do(ClientData clientData)
{
    int more_event;
    
    more_event=ev_fire_all_first();
    Tcl_Eval(M.interp, "update_time");

    if (more_event && ev_now() < M.stoptime && !M.paused  && !M.single_step) {
	Tk_CreateTimerHandler(M.delay, nothing2do, 0);
	// Tk_DoWhenIdle(nothing2do, 0); 
	// don't use this; the GUI response will be very slow
    }
}


// ---------------------------------------------------------
//
//
//  where to put the node-graph and space-time diagram
//
//
// --------------------------------------------------------


extern "C" int make_node_graph(char *args)
{
    char buf[1024], key[32];
    int  node, x, y;
    
    sscanf(args, "%s%d%d%d", key, &node, &x, &y);
    if (node<1 || node>10) {
	dprintf(-1," make_node_graph: Bad value node=%d\n", node);
	return -1;
    }
    sprintf(buf, "make_node_dialog %d +%d+%d", node, x, y);
    if (M.doX)   Tcl_Eval(M.interp, buf);

	return 0;
}

extern "C" int make_space_time(char *args)
{
    char buf[1024], key[32];
    int  st1, st2, x, y;
    
    sscanf(args, "%s%d%d%d%d", key, &st1, &st2, &x, &y);
    if (st1<1 || st1>10 || st2<1 || st2>10) {
	dprintf(-1," make_space_time: Bad value st1=%d st2=%d\n", st1, st2);
	return -1;
    }
    sprintf(buf, "make_node_space_time %d %d +%d+%d", st1, st2, x, y);
    if (M.doX)   Tcl_Eval(M.interp, buf);

	return 0;
}

