
/* CISE: This file is adapted from Sun Microsystems, Inc.  Tcl/tk tkWin.h */ 
/*            It has been modified for CISE Win95 Version */
/*
 * The TkWinDrawable is the internal implementation of an X Drawable (either
 * a Window or a Pixmap).  The following constants define the valid Drawable
 * types.
 */

#include "cisePort.h"

typedef int _TkWindow; /* virtual type, just for CISE Project Win95 Version*/

#define TWD_BITMAP	1
#define TWD_WINDOW	2
#define TWD_WINDC	3


typedef struct {
    int type;
    HWND handle;
    _TkWindow *winPtr;  /* adapted for CISE Win95 Port */
} TkWinWindow;

typedef struct {
    int type;
    HBITMAP handle;
    Colormap colormap;
    int depth;
} TkWinBitmap;

typedef struct {
    int type;
    HDC hdc;
}TkWinDC;

typedef union {
    int type;
    TkWinWindow window;
    TkWinBitmap bitmap;
    TkWinDC winDC;
} TkWinDrawable;

